import type { ComponentLogger, MultiaddrConnection, Stream } from '@libp2p/interface';
import type { Multiaddr } from '@multiformats/multiaddr';
import type { Uint8ArrayList } from 'uint8arraylist';
export interface StreamProperties {
    stream: Stream;
    remoteAddr: Multiaddr;
    localAddr: Multiaddr;
    logger: ComponentLogger;
    /**
     * A callback invoked when data is read from the stream
     */
    onDataRead?(buf: Uint8ArrayList | Uint8Array): void;
    /**
     * A callback invoked when data is written to the stream
     */
    onDataWrite?(buf: Uint8ArrayList | Uint8Array): void;
}
/**
 * Convert a duplex iterable into a MultiaddrConnection.
 * https://github.com/libp2p/interface-transport#multiaddrconnection
 */
export declare function streamToMaConnection(props: StreamProperties): MultiaddrConnection;
//# sourceMappingURL=stream-to-ma-conn.d.ts.map